<template>
	<div class="quality-template-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent>
				<el-form-item label="模版名称" prop="Name">
					<el-input v-model="state.queryParams.Name" placeholder="请填写模版名称" clearable @keyup.enter="handleQuery" class="keyword-input" />
				</el-form-item>
				<el-form-item label="质检分类" prop="Grouping">
					<el-select v-model="state.queryParams.Grouping" placeholder="请选择质检分类" @change="handleQuery">
						<el-option v-for="item in templateGrouping" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" v-waves class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: handleQuery,
				}"
			>
				<template #buttons>
					<el-button type="primary" @click="onTemplateAdd" v-auth="'quality:template:add'">
						<SvgIcon name="ele-Plus" class="mr5" />新增质检模板</el-button
					>
					<el-button type="danger" @click="onTemplateDelete" v-auth="'quality:template:delete'" :disabled="isChecked">
						<SvgIcon name="ele-Delete" class="mr5" />删除
					</el-button>
				</template>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true }"
					:row-config="{ isCurrent: true, isHover: true, height: 30, useKey: true }"
					ref="tableRef"
					height="auto"
					auto-resize
					show-overflow
					:scrollY="{ enabled: true, gt: 100 }"
					id="qualityTemplate"
					:custom-config="{ storage: true }"
					showHeaderOverflow
					@checkbox-all="selectAllChangeEvent"
					@checkbox-change="selectChangeEvent"
				>
					<vxe-column type="checkbox" width="50" align="center"></vxe-column>
					<vxe-column field="name" title="质检项名称" min-width="150"></vxe-column>
					<vxe-column field="groupingText" title="质检分类" width="150"></vxe-column>
					<vxe-column field="isEnable" title="是否启用" width="100">
						<template #default="{ row }">
							<template v-if="auth('quality:template:edit')">
								<el-switch
									v-model="row.isEnable"
									active-text="启用"
									inactive-text="禁用"
									:active-value="1"
									:inactive-value="0"
									@change="changeIsEnable(row)"
									inline-prompt
									size="small"
								/>
							</template>
							<span v-else>{{ row.isEnable ? '已启用' : '已禁用' }}</span>
						</template>
					</vxe-column>
					<vxe-column field="creatorName" title="创建人" width="120"></vxe-column>
					<vxe-column field="creationTime" title="创建时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
					<vxe-column field="lastModificationName" title="更新人" width="120"></vxe-column>
					<vxe-column field="lastModificationTime" title="更新时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.lastModificationTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
					<vxe-column title="操作" fixed="right" width="90" align="center">
						<template #default="{ row }">
							<el-button link type="primary" @click="onTemplateEdit(row)" v-auth="'quality:template:edit'" title="编辑模板"> 编辑 </el-button>
						</template>
					</vxe-column>
				</vxe-table>
			</div>
			<pagination
				@pagination="queryList"
				:total="state.total"
				v-model:current-page="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
				:disabled="state.loading"
			/>
		</div>
		<!--  模板新增  -->
		<quality-template-add ref="templateAdd" @updateList="queryList" :templateGrouping="templateGrouping" />
		<!--  模板编辑  -->
		<quality-template-edit ref="templateEditRef" @updateList="queryList" :templateGrouping="templateGrouping" />
	</div>
</template>

<script lang="tsx" setup name="qualityTemplate">
import { computed, defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { ElMessage, ElMessageBox, FormInstance } from 'element-plus';
import { formatDate } from '@/utils/formatTime';
import { auth } from '@/utils/authFunction';
import { templateBaseData, templateDelete, templateList, templateUpdate } from '@/api/quality/template';

// 引入组件
const QualityTemplateAdd = defineAsyncComponent(() => import('@/views/quality/template/components/Template-add.vue')); // 模板新增
const QualityTemplateEdit = defineAsyncComponent(() => import('@/views/quality/template/components/Template-edit.vue')); // 模板编辑
const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义变量内容
const state = reactive({
	loading: false, // 加载状态
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 20,
		Grouping: null,
		Name: null,
	},
	total: 0, // 总条数
	tableData: [], // 表格数据
});
const ruleFormRef = ref<RefType>(null); // 表单ref
const templateGrouping = ref<EmptyArrayType>([]); // 质检分组
const getBaseData = async () => {
	try {
		const res = await templateBaseData();
		templateGrouping.value = res.result?.templateGrouping ?? [];
	} catch (error) {
		console.log(error);
	}
};
// 手动查询，将页码设置为1
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
// 获取参数列表
const queryList = () => {
	state.loading = true;
	templateList(state.queryParams)
		.then((res) => {
			state.loading = false;
			state.tableData = res.result.items ?? [];
			state.total = res.result.total ?? 0;
			tableRef.value.clearCheckboxRow();
			checkTable.value = [];
		})
		.finally(() => {
			state.loading = false;
			tableRef.value.clearCheckboxRow();
			checkTable.value = [];
		});
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 新增意见
const templateAdd = ref<RefType>(); // 意见新增
const onTemplateAdd = () => {
	templateAdd.value.openDialog();
};
// 修改意见
const templateEditRef = ref<RefType>(); // 修改意见
const onTemplateEdit = (row: any) => {
	templateEditRef.value.openDialog(row);
};
//  修改是否启用
const changeIsEnable = (row: any) => {
	row.isEnable = row.isEnable === 1 ? 0 : 1; //保持switch点击前的状态
	ElMessageBox.confirm(`您确定要${row.isEnable === 1 ? '禁用' : '启用'}：【${row.name}】模板，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			const isEnable = row.isEnable === 1 ? 0 : 1;
			const request = {
				...row,
				isEnable: isEnable,
			};
			templateUpdate(request)
				.then(() => {
					ElMessage.success('操作成功');
					queryList();
				})
				.catch(() => {
					queryList();
				});
		})
		.catch(() => {
			queryList();
		});
};
// 删除参数
const onTemplateDelete = () => {
	const ids = checkTable.value.map((item: any) => item.id);
	ElMessageBox.confirm(`您确定要删除选中的质检模板，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			templateDelete({ ids }).then(() => {
				ElMessage.success('删除成功');
				queryList();
			});
		})
		.catch(() => {});
};
const tableRef = ref<RefType>();
const checkTable = ref<EmptyArrayType>([]);
const selectAllChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '所有勾选事件' : '所有取消事件', records);
	}
};

const selectChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '勾选事件' : '取消事件', records);
	}
};
const isChecked = computed(() => {
	return !Boolean(checkTable.value.length);
});
const toolbarRef = ref<RefType>();
// 页面加载时
onMounted(() => {
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
	getBaseData();
});
</script>
